Listview for Javascript

Updated on May 17, 2021
Learn More

Advanced list view component with gesture, swipe and drag & drop support.

Use it along Mobiscroll forms, pages or in any web or mobile hybrid app. Suited for small to large screens.

Shipping with useful features for a refined UX, including:

  • Support for alternating row color
  • Use it with single, multi-line text or custom content
  • Render cards instead of full-width rows
  • Enhance content with images, avatars and icons
  • Built-in support for sorting and ordering
  • Multiple data-source support
  • Load on demand capabilities
  • Top positioned sticy header for segmenting the list
  • Simple to advanced grouping capabilities
  • CRUD with undo functionality
  • Full-blown gesture support
  • Hierarchical listviews with variable depth
  • Multiple theme support



As part of Gesture enabled listview it can be picked up with the Framework and Complete licenses or with the component license.


Listview available for other frameworks.

Viewing demos & code for

Javascript Listview Listview for Javascript

Listview - Basic

Change demo
Basic
Javascript Listview demo for creating a simple list of items. Add stripes for alternating background colors of list items. Plain JS api for usage everywhere.
Copy code

Listview - Content

Change demo
Content
Javascript Listview demo for rendering different types of content. Use it for multi-line text, cards or any content with custom CSS. Plain JS api for usage everywhere.
Copy code

Listview - Image/Icon/Avatar

Change demo
Image/Icon/Avatar
Javascript Listview image demo for rendering content with regular images, icons and avatars. Customize it with custom CSS. Plain JS api for usage everywhere.
Copy code

Listview - Selecting items

Change demo
Selecting items
Javascript Listview item selection example. Select a single item or enable multiple selection for batch operations. Plain JS api for usage everywhere.
Copy code

Listview - Sorting & ordering

Change demo
Sorting & ordering
Javascript Listview reorder demo. Grab and sort from drag handle on the left or right side, or tap/click and hold to sort. Plain JS api for usage everywhere.
Copy code

Listview - Sticky header

Change demo
Sticky header
Javascript Listview demo with sticky header. List out names or contacts grouped alphabetically with the first letter on top. Plain JS api for usage everywhere.
Copy code

Listview - Grouping

Change demo
Grouping
Javascript Listview demo with group headers. Use it to logically segment and group items without creating multiple lists. Plain JS api for usage everywhere.
Copy code

Listview - Create, Read, Update, Delete

Change demo
Create, Read, Update, Delete
Javascript Listview demo with CRUD operations & swipe actions. Slide right to update and left to delete items. Plain JS api for usage everywhere.
Copy code

Listview - Remove/Undo

Change demo
Remove/Undo
Javascript Listview demo with swipe-away delete and built-in undo functionality. Use it for laying out notifications or any data. Plain JS api for usage everywhere.
Copy code

Listview - Swipe actions

Change demo
Swipe actions
Javascript Listview demo with swipe revealing actions. Render an action list or action menu when sliding items left and right. Plain JS api for usage everywhere.
Copy code

Listview - Hierarchy

Change demo
Hierarchy
Javascript Listview with multi-level hierarchy and drill-down interface. Featuring images, icons and text. Plain JS api for usage everywhere.
Copy code

Listview - Checklist

Change demo
Checklist
Javascript Drag & Drop checklist/tasklist with swipe actions to add/remove items from todo listview. Sorting is supported. Plain JS api for usage everywhere.
Copy code

Listview - Filtering

Change demo
Filtering
Javascript Listview demo with dynamic data and live filtering. Add and remove items on the fly or reload the full list. Plain JS api for usage everywhere.
Copy code

Listview - Data sources

Change demo
Data sources
Javascript Listview demo with different ways of getting and passing data. Supporting hardcoded lists, dynamic and remote data. Plain JS api for usage everywhere.
Copy code

Listview - Load on demand

Change demo
Load on demand
Javascript Listview load on demand demo. Load data from a REST service and populate the list as users scroll content. Plain JS api for usage everywhere.
Copy code

Listview - Load more

Change demo
Load more
Javascript Listview demo with load more button for loading additional items from a REST service. Get and display records from JSON. Plain JS api for usage everywhere.
Copy code

Listview - Master-detail view

Change demo
Master-detail view

Build a two pane master-detail view with the help of the listview. Use the grid layout to set up the two columns - left side for a list of names, right side for showing the details. If you want to get into the details you could even hide the first column and build a drawer or use a hamburger menu for the master list.

Use the navigation component for the tabs and cards for building the layout of the details view.

Want to learn more about building responsive layouts?  Check out the grid layout →
Copy code
mobiscroll.settings = {
    lang: ' ',
    theme: ' ',
    themeVariant: ' '
};

function createProfiles(data) {
    for (var i = 0; i < data.length; ++i) {
        var elm = document.querySelectorAll('.master-tab-profile')[i],
            pers = data[i];

        elm.innerHTML =
            '<div mbsc-card><div class="mbsc-card-content"><div class="mbsc-row">' +
            '<div class="mbsc-col-md-6 mbsc-col-12">' +
            '<label>First name <input mbsc-input datal value="' + pers.first + '" data-input-style="box" data-label-style="floating" /></label>' +
            '</div><div class="mbsc-col-md-6 mbsc-col-12">' +
            '<label>Last name<input mbsc-input datal value="' + pers.last + '" data-input-style="box" data-label-style="floating" /></label>' +
            '</div></div><div class="mbsc-row"><div class="mbsc-col-md-6 mbsc-col-12">' +
            '<label>Email<input mbsc-input datal value="' + pers.email + '" data-input-style="box" data-label-style="floating" /></label>' +
            '</div></div><div class="mbsc-row"><div class="mbsc-col-md-6 mbsc-col-12">' +
            '<label>Company<input mbsc-input datal value="' + pers.company + '" data-input-style="box" data-label-style="floating" /></label>' +
            '</div><div class="mbsc-col-md-6 mbsc-col-12">' +
            '<label>Role<select mbsc-dropdown data-input-style="box" data-label-style="floating">' +
            '<option value="ceo"' + (pers.role == 'ceo' ? 'selected' : '') + '>CEO</option>' +
            '<option value="cto"' + (pers.role == 'cto' ? 'selected' : '') + '>CTO</option>' +
            '<option value="vpp"' + (pers.role == 'vpp' ? 'selected' : '') + '>VP of Product</option>' +
            '<option value="vpm"' + (pers.role == 'vpm' ? 'selected' : '') + '>VP of Marketing</option>' +
            '<option value="vpe"' + (pers.role == 'vpe' ? 'selected' : '') + '>VP of Engineering</option>' + '</select></label>' +
            '</div></div><div class="mbsc-row"><div class="mbsc-col-md-6 mbsc-col-12">' +
            '<label>Notes<textarea mbsc-textarea data-input-style="box" data-label-style="floating">' + pers.notes + '</textarea></label>' +
            '</div></div><div class="mbsc-row mbsc-justify-content-end"><div class="mbsc-col-md-6 mbsc-col-12"><div class="mbsc-pull-right mbsc-btn-group">' +
            '<button mbsc-button class="mbsc-btn-primary">Update</button>' +
            '<button mbsc-button class="mbsc-btn-secondary">Email</button>' +
            '<button mbsc-button class="mbsc-btn-secondary">Call</button>' +
            '<button mbsc-button class="mbsc-btn-secondary">Meet</button>' +
            '</div></div></div></div></div>';

        elm.dispatchEvent(new Event('mbsc-enhance', { bubbles: true }));
    }
}

function createConversations(data) {
    for (var i = 0; i < data.length; ++i) {
        var elm = document.querySelectorAll('.master-tab-conv')[i],
            convs = data[i].conv,
            conv = '';

        for (var j = 0; j < convs.length; ++j) {
            var c = convs[j];

            conv = conv + '<div mbsc-card data-collapsible data-open><div class="mbsc-card-header"><span class="mbsc-bold">' + c.title +
                '</span><span class="mbsc-pull-right mbsc-card-subtitle">' + mobiscroll.util.datetime.formatDate('D, d h:ii A', new Date(c.date)) +
                '</span></div><div class="mbsc-card-content">' + c.text + '</div></div>';
        }

        elm.innerHTML = conv;
        elm.dispatchEvent(new Event('mbsc-enhance', { bubbles: true }));
    }
}

function createTasks(data) {
    for (var i = 0; i < data.length; ++i) {
        var elm = document.querySelectorAll('.master-tab-tasks')[i],
            task = data[i].tasks;

        elm.innerHTML =
            '<div mbsc-card><div class="mbsc-card-header"><h2 class="mbsc-card-title">' +
            'Qualification process with lead</h2></div><div class="mbsc-card-content mbsc-no-padding">' +
            '<label>Understanding business problem we can fix.<input mbsc-checkbox type="checkbox"' + (task[0] ? 'checked' : '') + '></label>' +
            '<label>How are they solving the problem at the moment?<input mbsc-checkbox type="checkbox"' + (task[1] ? 'checked' : '') + '></label>' +
            '<label>Do you have a budget allocated to solve this problem?<input mbsc-checkbox type="checkbox"' + (task[2] ? 'checked' : '') + '></label>' +
            '<label>Understanding the budget signoff process.<input mbsc-checkbox type="checkbox"' + (task[3] ? 'checked' : '') + '></label>' +
            '<label>What other solutions are you evaluating?<input mbsc-checkbox type="checkbox"' + (task[4] ? 'checked' : '') + '></label>' +
            '<label>What does success look like?<input mbsc-checkbox type="checkbox"' + (task[5] ? 'checked' : '') + '></label>' +
            '<label>What does solving the problem mean to you personally?<input mbsc-checkbox type="checkbox"' + (task[6] ? 'checked' : '') + '></label>' +
            '<label>What\'s the deadline?<input mbsc-checkbox type="checkbox"' + (task[7] ? 'checked' : '') + '></label></div></div>';

        elm.dispatchEvent(new Event('mbsc-enhance', { bubbles: true }));
    }
}

mobiscroll.listview('#master-detail-list', {
    select: 'single',
    onItemTap: function (event, inst) {
        document.querySelector('.md-master-item-sel').classList.remove('md-master-item-sel');
        document.querySelector('#master-item-' + event.target.getAttribute('data-item')).classList.add('md-master-item-sel');
        // resize textarea
        if (document.querySelector('.md-master-item-sel textarea')) {
            document.querySelector('.md-master-item-sel textarea').dispatchEvent(new Event('mbsc-enhance', { bubbles: true }));
        }
    }
});

mobiscroll.nav('#master-detail-tab', {
    type: 'tab',
    display: 'inline',
    onInit: function (event, inst) {
        mobiscroll.util.getJson('https://trial.mobiscroll.com/master-detail/', function (data) {
            createProfiles(data);
            createConversations(data);
            createTasks(data);
        }, 'jsonp');
    },
    onItemTap: function (event, inst) {
        var oldTabs = document.querySelectorAll('.md-master-tab-sel');
        var selTabs = document.querySelectorAll('.master-tab-' + event.target.getAttribute('data-tab'));

        for (var i = 0; i < oldTabs.length; ++i) {
            oldTabs[i].classList.remove('md-master-tab-sel');
            selTabs[i].classList.add('md-master-tab-sel');
        }
        // resize textarea
        if (document.querySelector('.md-master-tab-sel textarea')) {
            document.querySelector('.md-master-tab-sel textarea').dispatchEvent(new Event('mbsc-enhance', { bubbles: true }));
        }
    }
});
<div mbsc-form class="md-master-detail-demo">
    <div class="mbsc-grid mbsc-no-padding">
        <div class="mbsc-row">
            <div class="mbsc-col-12 mbsc-col-md-2 mbsc-col-sm-3">
                <ul id="master-detail-list" class="mbsc-cloak">
                    <li data-item="a" data-selected="true">Ashlee Conner</li>
                    <li data-item="b">Bianca Baker</li>
                    <li data-item="c">Christopher Tran</li>
                    <li data-item="k">Konner Stone</li>
                    <li data-item="l">Leon Medina</li>
                    <li data-item="n">Nora Leonard</li>
                    <li data-item="o">Octavio Daniels</li>
                    <li data-item="r">Russell Wang</li>
                    <li data-item="t">Teresa Livingston</li>
                    <li data-item="z">Zoe Gilbert</li>
                </ul>
            </div>
            <div class="mbsc-col-12 mbsc-col-md-10 mbsc-col-sm-9 md-col-border">
                <ul id="master-detail-tab" class="mbsc-cloak">
                    <li data-tab="profile" data-selected="true">Profile</li>
                    <li data-tab="conv">Conversations</li>
                    <li data-tab="tasks">Tasks</li>
                </ul>
                <div id="master-item-a" class="md-master-item md-master-item-sel mbsc-form-grid">
                    <div class="master-tab-profile md-master-tab md-master-tab-sel"></div>
                    <div class="master-tab-conv md-master-tab"></div>
                    <div class="master-tab-tasks md-master-tab"></div>
                </div>
                <div id="master-item-b" class="md-master-item mbsc-form-grid">
                    <div class="master-tab-profile md-master-tab md-master-tab-sel"></div>
                    <div class="master-tab-conv md-master-tab"></div>
                    <div class="master-tab-tasks md-master-tab"></div>
                </div>
                <div id="master-item-c" class="md-master-item mbsc-form-grid">
                    <div class="master-tab-profile md-master-tab md-master-tab-sel"></div>
                    <div class="master-tab-conv md-master-tab"></div>
                    <div class="master-tab-tasks md-master-tab"></div>
                </div>
                <div id="master-item-k" class="md-master-item mbsc-form-grid">
                    <div class="master-tab-profile md-master-tab md-master-tab-sel"></div>
                    <div class="master-tab-conv md-master-tab"></div>
                    <div class="master-tab-tasks md-master-tab"></div>
                </div>
                <div id="master-item-l" class="md-master-item mbsc-form-grid">
                    <div class="master-tab-profile md-master-tab md-master-tab-sel"></div>
                    <div class="master-tab-conv md-master-tab"></div>
                    <div class="master-tab-tasks md-master-tab"></div>
                </div>
                <div id="master-item-n" class="md-master-item mbsc-form-grid">
                    <div class="master-tab-profile md-master-tab md-master-tab-sel"></div>
                    <div class="master-tab-conv md-master-tab"></div>
                    <div class="master-tab-tasks md-master-tab"></div>
                </div>
                <div id="master-item-o" class="md-master-item mbsc-form-grid">
                    <div class="master-tab-profile md-master-tab md-master-tab-sel"></div>
                    <div class="master-tab-conv md-master-tab"></div>
                    <div class="master-tab-tasks md-master-tab"></div>
                </div>
                <div id="master-item-r" class="md-master-item mbsc-form-grid">
                    <div class="master-tab-profile md-master-tab md-master-tab-sel"></div>
                    <div class="master-tab-conv md-master-tab"></div>
                    <div class="master-tab-tasks md-master-tab"></div>
                </div>
                <div id="master-item-t" class="md-master-item mbsc-form-grid">
                    <div class="master-tab-profile md-master-tab md-master-tab-sel"></div>
                    <div class="master-tab-conv md-master-tab"></div>
                    <div class="master-tab-tasks md-master-tab"></div>
                </div>
                <div id="master-item-z" class="md-master-item mbsc-form-grid">
                    <div class="master-tab-profile md-master-tab md-master-tab-sel"></div>
                    <div class="master-tab-conv md-master-tab"></div>
                    <div class="master-tab-tasks md-master-tab"></div>
                </div>
            </div>
        </div>
    </div>
</div>
.demo-main-cont.demo-comp-listview { padding: 0; }
.demo-comp-listview .demo-note { margin: 10px; }

.md-master-detail-demo,
.md-master-detail-demo .mbsc-row {
    height: 100%;
}

.md-master-detail-demo .mbsc-grid {
    height: 100%;
}

.md-master-detail-demo .md-col-border {
    overflow: auto;
    height: 100%;
    min-height: 800px;
    border-left: 1px solid #ccc;
}

.md-master-detail-demo .mbsc-ms-c {
    border-top: 0;
}

.md-master-tab,
.md-master-item {
    display: none;
}

.md-master-tab-sel,
.md-master-item-sel {
    display: block;
}

Listview - Event handlers

Change demo
Event handlers
Javascript Listview demo with event hooks for deep integration and custom functionality. With source code. Plain JS api for usage everywhere.
Clear event log
EVENTS FIRED: 
Copy code

Listview - Quick Navigation

Change demo
Quick Navigation
Javascript Listview demo with quick access to list segments. Alphabetically group items and provide a tab list for selection. Plain JS api for usage everywhere.
Copy code

Looking for something you didn't see or have a sales question?
Ask us about it, we're here to help.

Customize & try demos locally
Sign in or start your free trial

What framework are you using?

Javascript
jQuery
AngularJS
Angular
React
Other
Ionic Angular
Email address

Install demo in your app
Follow this quick, two minute install guide
Close window

Step 1.Install the Mobiscroll CLI from npm

Copy command
$ npm install -g @mobiscroll/cli

The CLI makes configuring your apps super simple 👍

Step 2.Run the following command in the root folder of your Ionic project

Copy command
$ mobiscroll config ionic --version=4

You will be prompted to log in with your mobiscroll account. Set your password here

Create an Ionic 3 & Mobiscroll starter with the CLI:

$ mobiscroll start ionic myStarter

Run this command for Ionic 4 & Mobiscroll starter:

$ mobiscroll start ionic-angular myStarter

Step 3.Copy the code into your app.

Copy TS
Copy HTML
Copy CSS
Copy Module

Step 4.Run ionic serve in the root folder of your app 🎉

Copy command
$ ionic serve

And voilà, everything should be running smoothly.

Install demo in your app
Follow this quick, two minute install guide
Close window

Step 1.Install the Mobiscroll CLI from npm

Copy command
$ npm install -g @mobiscroll/cli

The CLI makes configuring your apps super simple 👍

Step 2.Run the following command in the root folder of your Ionic project

Copy command
$ mobiscroll config ionic --version=4

You will be prompted to log in with your mobiscroll account. Set your password here

Run this command for Ionic 5 & React Mobiscroll starter:

$ mobiscroll start react-ionic myStarter

Step 3.Copy the code into your app.

Copy TSX
Copy CSS

Step 4.Run ionic serve in the root folder of your app 🎉

Copy command
$ ionic serve

And voilà, everything should be running smoothly.

Customize & try demos locally
How would you like to do it?
Install demo in your app
Follow this quick, two minute install guide
Close window

Step 1.Install the Mobiscroll CLI from npm

Copy command
$ npm install -g @mobiscroll/cli

The CLI makes configuring your apps super simple 👍

Step 2.Run the following command in the root folder of your Angular project

Copy command
$ mobiscroll config angular --version=4

You will be prompted to log in with your mobiscroll account. Set your password here

Step 3.Copy the code into your app. HTML goes into the markup, TS into Typescript.

Copy TS
Copy HTML
Copy CSS
Copy Module

Step 4.Run ng serve in the root folder of your app 🎉

Copy command
$ ng serve

And voilà, everything should be running smoothly.

Thanks for downloading
Try and customize the app locally

Extract the zip file and run the project like any Ionic app. Make sure to have Ionic CLI installed and open the terminal in the app root folder.

Step 1. Run in root folder
$ npm install
Step 2. Start the app
$ ionic serve

Let us know if we can help and enjoy!

Thanks for downloading
Customize demos locally

Everything is set up so that you can dig in right away and start exploring.

We have set up a trial so that you can try the demos locally.

Extract the zip file and open the demo in your favorite browser. To install Mobiscroll in your project follow instructions from this page.


Let us know if we can help and enjoy! 👍

Thanks for downloading
Customize demos locally

Please extract the zip file and run the project like any Angular CLI app. Make sure to have the Angular CLI installed.

For installation and usage, extract the zip file and open a terminal window and follow these steps.

Step 1. Run in root folder
$ npm install
Step 2. Start the app
$ ng serve --open

Let us know if we can help and enjoy! 👍

Thanks for downloading
Customize demos locally

Everything is set up so that you can dig in right away and start exploring.

We have set up a trial so that you can try the demos locally.

The easiest way to get started is to follow the installation steps and by grabbing the code directly from the demo page. Let us know if we can help and enjoy! 👍

You'll find a fully functional Kitchen-sink Ionic app in the zip file.

Thanks for downloading
Customize demos locally

Everything is set up so that you can dig in right away and start exploring.

We have set up a trial so that you can try the demos locally.

The demos are using Babel's in-browser ES6 and JSX transformer.
Extract the zip file and open the demo in your browser. To install Mobiscroll in your project follow instructions from this page.


Let us know if we can help and enjoy! 👍

Customize & try this demo locally
Sign in or start your free trial

We have to set you up with a trial for this to run 👍

Email address

Need to update your password?
Demos
Theme Select
Mobiscroll
Material
Material Dark
iOS
iOS Dark
Windows
Windows Dark
Language Locale
See other demos and change options
Theme
Locale
See other demos

Listview for React

Updated on May 17, 2021
Learn More

Advanced list view component with gesture, swipe and drag & drop support.

Use it along Mobiscroll forms, pages or in any web or mobile hybrid app. Suited for small to large screens.

Shipping with useful features for a refined UX, including:

  • Support for alternating row color
  • Use it with single, multi-line text or custom content
  • Render cards instead of full-width rows
  • Enhance content with images, avatars and icons
  • Built-in support for sorting and ordering
  • Multiple data-source support
  • Load on demand capabilities
  • Top positioned sticy header for segmenting the list
  • Simple to advanced grouping capabilities
  • CRUD with undo functionality
  • Full-blown gesture support
  • Hierarchical listviews with variable depth
  • Multiple theme support



As part of Gesture enabled listview it can be picked up with the Framework and Complete licenses or with the component license.


Listview available for other frameworks.

Viewing demos & code for

React Listview Listview for React

Listview - Basic

Change demo
Basic
React Listview demo for creating a simple list of items. Add stripes for alternating background colors of list items. For React and Next.JS.
Copy code

Listview - Content

Change demo
Content
React Listview demo for rendering different types of content. Use it for multi-line text, cards or any content with custom CSS. For React and Next.JS.
Copy code

Listview - Image/Icon/Avatar

Change demo
Image/Icon/Avatar
React Listview image demo for rendering content with regular images, icons and avatars. Customize it with custom CSS. For React and Next.JS.
Copy code

Listview - Selecting items

Change demo
Selecting items
React Listview item selection example. Select a single item or enable multiple selection for batch operations. For React and Next.JS.
Copy code

Listview - Sorting & ordering

Change demo
Sorting & ordering
React Listview reorder demo. Grab and sort from drag handle on the left or right side, or tap/click and hold to sort. For React and Next.JS.
Copy code

Listview - Sticky header

Change demo
Sticky header
React Listview demo with sticky header. List out names or contacts grouped alphabetically with the first letter on top. For React and Next.JS.
Copy code

Listview - Grouping

Change demo
Grouping
React Listview demo with group headers. Use it to logically segment and group items without creating multiple lists. For React and Next.JS.
Copy code

Listview - Create, Read, Update, Delete

Change demo
Create, Read, Update, Delete
React Listview demo with CRUD operations & swipe actions. Slide right to update and left to delete items. For React and Next.JS.
Copy code

Listview - Remove/Undo

Change demo
Remove/Undo
React Listview demo with swipe-away delete and built-in undo functionality. Use it for laying out notifications or any data. For React and Next.JS.
Copy code

Listview - Swipe actions

Change demo
Swipe actions
React Listview demo with swipe revealing actions. Render an action list or action menu when sliding items left and right. For React and Next.JS.
Copy code

Listview - Hierarchy

Change demo
Hierarchy
React Listview with multi-level hierarchy and drill-down interface. Featuring images, icons and text. For React and Next.JS.
Copy code

Listview - Checklist

Change demo
Checklist
React Drag & Drop checklist/tasklist with swipe actions to add/remove items from todo listview. Sorting is supported. For React and Next.JS.
Copy code

Listview - Filtering

Change demo
Filtering
React Listview demo with dynamic data and live filtering. Add and remove items on the fly or reload the full list. For React and Next.JS.
Copy code

Listview - Data sources

Change demo
Data sources
React Listview demo with different ways of getting and passing data. Supporting hardcoded lists, dynamic and remote data. For React and Next.JS.
Copy code

Listview - Load on demand

Change demo
Load on demand
React Listview load on demand demo. Load data from a REST service and populate the list as users scroll content. For React and Next.JS.
Copy code

Listview - Load more

Change demo
Load more
React Listview demo with load more button for loading additional items from a REST service. Get and display records from JSON. For React and Next.JS.
Copy code

Listview - Master-detail view

Change demo
Master-detail view

Build a two pane master-detail view with the help of the listview. Use the grid layout to set up the two columns - left side for a list of names, right side for showing the details. If you want to get into the details you could even hide the first column and build a drawer or use a hamburger menu for the master list.

Use the navigation component for the tabs and cards for building the layout of the details view.

Want to learn more about building responsive layouts?  Check out the grid layout →
Copy code
import mobiscroll from '@mobiscroll/react';
import '@mobiscroll/react/dist/css/mobiscroll.min.css';

mobiscroll.settings = {
    lang: ' ',
    theme: ' ',
    themeVariant: ' '
};

class ListItem extends React.Component {
    render() {
         return <li data-selected={this.props.item.selected}>{this.props.item.name}</li>;
    }
}

class App extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            people: [
                { id: 0, name: 'Ashlee Conner', selected: true },
                { id: 1, name: 'Bianca Baker', selected: false },
                { id: 2, name: 'Christopher Tran', selected: false },
                { id: 3, name: 'Konner Stone', selected: false },
                { id: 4, name: 'Leon Medina', selected: false },
                { id: 5, name: 'Nora Leonard', selected: false },
                { id: 6, name: 'Octavio Daniels', selected: false },
                { id: 7, name: 'Russell Wang', selected: false },
                { id: 8, name: 'Teresa Livingston', selected: false },
                { id: 9, name: 'Zoe Gilbert', selected: false }
            ],
            selectedUser: null,
            selectedTab: 'profile',
            data: []
        } 
        
        this.getData();
    }
    
    render() {
        let content;
        const selectedUser = this.state.selectedUser;
        
        switch (this.state.selectedTab) {
            case 'profile':
                if(selectedUser !== null) {
                    content = <div className="mbsc-form-grid">
                         <mobiscroll.Card>
                            <mobiscroll.CardContent>
                                <div className="mbsc-row">
                                    <div className="mbsc-col-md-6 mbsc-col-12">
                                        <mobiscroll.Input value={selectedUser.first} onChange={this.changeFirstName} inputStyle="box" labelStyle="floating">First name</mobiscroll.Input>
                                    </div>
                                    <div className="mbsc-col-md-6 mbsc-col-12">
                                        <mobiscroll.Input value={selectedUser.last} onChange={this.changeLastName} inputStyle="box" labelStyle="floating">Last name</mobiscroll.Input>
                                    </div>
                                </div>
                                <div className="mbsc-row">
                                    <div className="mbsc-col-md-6 mbsc-col-12">
                                        <mobiscroll.Input value={selectedUser.email} onChange={this.changeEmail} inputStyle="box" labelStyle="floating">Email</mobiscroll.Input>
                                    </div>
                                </div>
                                <div className="mbsc-row">
                                    <div className="mbsc-col-md-6 mbsc-col-12">
                                        <mobiscroll.Input value={selectedUser.company} onChange={this.changeCompany} inputStyle="box" labelStyle="floating">Company</mobiscroll.Input>
                                    </div>
                                    <div className="mbsc-col-md-6 mbsc-col-12">
                                        <mobiscroll.Dropdown value={selectedUser.role} onChange={this.changeRole} inputStyle="box" labelStyle="floating" label="Role">
                                            <option value="ceo">CEO</option>
                                            <option value="cto">CTO</option>
                                            <option value="vpp">VP of Product</option>
                                            <option value="vpm">VP of Marketing</option>
                                            <option value="vpe">VP of Engineering</option>
                                        </mobiscroll.Dropdown>
                                    </div>
                                </div>
                                <div className="mbsc-row">
                                    <div className="mbsc-col-md-6 mbsc-col-12">
                                        <mobiscroll.Textarea value={selectedUser.notes} onChange={this.changeNotes} inputStyle="box" labelStyle="floating">Notes</mobiscroll.Textarea>
                                    </div>
                                </div>
                                <div className="mbsc-row mbsc-justify-content-end">
                                    <div className="mbsc-col-md-6 mbsc-col-12">
                                        <div className="mbsc-pull-right mbsc-btn-group">
                                            <mobiscroll.Button color="primary">Update</mobiscroll.Button>
                                            <mobiscroll.Button color="secondary">Email</mobiscroll.Button>
                                            <mobiscroll.Button color="secondary">Call</mobiscroll.Button>
                                            <mobiscroll.Button color="secondary">Meet</mobiscroll.Button>
                                        </div>
                                    </div>
                                </div>
                            </mobiscroll.CardContent>
                        </mobiscroll.Card>
                    </div>
                }
                break;
            case 'conv':
                if(selectedUser !== null) {
                    content = <div className="mbsc-form-grid">
                        {selectedUser.conv.map((conv, key) => {
                            return (
                                <div key={key}>
                                    <mobiscroll.Card collapsible open>
                                        <mobiscroll.CardHeader>
                                            <span className="mbsc-bold">{conv.title}</span>
                                            <span className="mbsc-pull-right mbsc-card-subtitle">{this.formatDate(conv.date)}</span>
                                        </mobiscroll.CardHeader>
                                        <mobiscroll.CardContent>{conv.text}</mobiscroll.CardContent>
                                    </mobiscroll.Card>
                                </div>
                            );
                        })}
                    </div>
                }
                break;
            case 'tasks':
                if(selectedUser !== null) {
                    const selectedUser = this.state.selectedUser;
                    content = <div className="mbsc-form-grid">
                        <mobiscroll.Card>
                            <mobiscroll.CardHeader>
                                <h2 className="mbsc-card-title">Qualification process with lead</h2>
                            </mobiscroll.CardHeader>
                            <mobiscroll.CardContent className="mbsc-no-padding">
                                <mobiscroll.Checkbox checked={selectedUser.tasks[0]} onChange={this.setTasks.bind(this, 0)}>Understanding business problem we can fix.</mobiscroll.Checkbox>
                                <mobiscroll.Checkbox checked={selectedUser.tasks[1]} onChange={this.setTasks.bind(this, 1)}>How are they solving the problem at the moment?</mobiscroll.Checkbox>
                                <mobiscroll.Checkbox checked={selectedUser.tasks[2]} onChange={this.setTasks.bind(this, 2)}>Do you have a budget allocated to solve this problem?</mobiscroll.Checkbox>
                                <mobiscroll.Checkbox checked={selectedUser.tasks[3]} onChange={this.setTasks.bind(this, 3)}>Understanding the budget signoff process.</mobiscroll.Checkbox>
                                <mobiscroll.Checkbox checked={selectedUser.tasks[4]} onChange={this.setTasks.bind(this, 4)}>What other solutions are you evaluating?</mobiscroll.Checkbox>
                                <mobiscroll.Checkbox checked={selectedUser.tasks[5]} onChange={this.setTasks.bind(this, 5)}>What does success look like?</mobiscroll.Checkbox>
                                <mobiscroll.Checkbox checked={selectedUser.tasks[6]} onChange={this.setTasks.bind(this, 6)}>What does solving the problem mean to you personally?</mobiscroll.Checkbox>
                                <mobiscroll.Checkbox checked={selectedUser.tasks[7]} onChange={this.setTasks.bind(this, 7)}>What's the deadline?</mobiscroll.Checkbox>
                            </mobiscroll.CardContent>
                        </mobiscroll.Card>
                    </div>
                }
                break;
        }
        return (
            <mobiscroll.Form className="md-master-detail-demo">
                <div className="mbsc-grid mbsc-no-padding">
                    <div className="mbsc-row">
                        <div className="mbsc-col-12 mbsc-col-md-2 mbsc-col-sm-3">
                            <mobiscroll.Listview select="single" itemType={ListItem} data={this.state.people} onItemTap={this.changeUser} />
                        </div>
                        <div className="mbsc-col-12 mbsc-col-md-10 mbsc-col-sm-9 md-col-border">
                            <mobiscroll.TabNav display="inline">
                                <mobiscroll.NavItem selected={this.state.selectedTab == 'profile'} onClick={this.selectTab.bind(null, 'profile')}>Profile</mobiscroll.NavItem>
                                <mobiscroll.NavItem selected={this.state.selectedTab == 'conv'} onClick={this.selectTab.bind(null, 'conv')}>Conversations</mobiscroll.NavItem>
                                <mobiscroll.NavItem selected={this.state.selectedTab == 'tasks'} onClick={this.selectTab.bind(null, 'tasks')}>Tasks</mobiscroll.NavItem>
                            </mobiscroll.TabNav>
                            {content}
                        </div>
                    </div>
                </div>
            </mobiscroll.Form>
        );
    }
    
        getData() {
        mobiscroll.util.getJson('https://trial.mobiscroll.com/master-detail/', (data) => {
            this.setState({ data: data, selectedUser: data.length ? data[0] : null });
        }, 'jsonp');
    }
    
    selectTab = (newTab) => {
        this.setState({ selectedTab: newTab });
    }
    
    changeUser = (event, inst) => {
        this.setState({ selectedUser: this.state.data[event.index]});
    }
    
    changeFirstName = (event) => {
        const updatedUser = this.state.selectedUser;
        updatedUser.first = event.target.value;

        this.setState({ selectedUser: updatedUser });
    }
    
    changeLastName = (event) => {
        const updatedUser = this.state.selectedUser;
        updatedUser.last = event.target.value;

        this.setState({ selectedUser: updatedUser });
    }
    
    changeEmail = (event) => {
        const updatedUser = this.state.selectedUser;
        updatedUser.email = event.target.value;

        this.setState({ selectedUser: updatedUser });
    }
    
    changeCompany = (event) => {
        const updatedUser = this.state.selectedUser;
        updatedUser.company = event.target.value;

        this.setState({ selectedUser: updatedUser });
    }
    
    changeRole = (event) => {
        const updatedUser = this.state.selectedUser;
        updatedUser.role = event.target.value;

        this.setState({ selectedUser: updatedUser });
    }
    
    changeNotes = (event) => {
        const updatedUser = this.state.selectedUser;
        updatedUser.notes = event.target.value;

        this.setState({ selectedUser: updatedUser });
    }
    
    formatDate(date) {
        return mobiscroll.util.datetime.formatDate('D, d h:ii A', new Date(date));
    }
    
    setTasks = (index) => {
        const updatedUser = this.state.selectedUser;
        updatedUser.tasks[index] = event.target.checked;
        
        this.setState({ selectedUser: updatedUser });
    }
}


<div id="content"></div>
.demo-main-cont.demo-comp-listview { padding: 0; }
.demo-comp-listview .demo-note { margin: 10px; }

.md-master-detail-demo,
.md-master-detail-demo .mbsc-row {
    height: 100%;
}

.md-master-detail-demo .mbsc-grid {
    height: 100%;
}

.md-master-detail-demo .md-col-border {
    overflow: auto;
    height: 100%;
    min-height: 800px;
    border-left: 1px solid #ccc;
}

.md-master-detail-demo .mbsc-ms-c {
    border-top: 0;
}

.md-master-tab,
.md-master-item {
    display: none;
}

.md-master-tab-sel,
.md-master-item-sel {
    display: block;
}

Listview - Event handlers

Change demo
Event handlers
React Listview demo with event hooks for deep integration and custom functionality. With source code. For React and Next.JS.
Clear event log
EVENTS FIRED: 
Copy code

Listview - Quick Navigation

Change demo
Quick Navigation
React Listview demo with quick access to list segments. Alphabetically group items and provide a tab list for selection. For React and Next.JS.
Copy code

Looking for something you didn't see or have a sales question?
Ask us about it, we're here to help.

Customize & try demos locally
Sign in or start your free trial

What framework are you using?

Javascript
jQuery
AngularJS
Angular
React
Other
Ionic Angular
Email address

Install demo in your app
Follow this quick, two minute install guide
Close window

Step 1.Install the Mobiscroll CLI from npm

Copy command
$ npm install -g @mobiscroll/cli

The CLI makes configuring your apps super simple 👍

Step 2.Run the following command in the root folder of your Ionic project

Copy command
$ mobiscroll config ionic --version=4

You will be prompted to log in with your mobiscroll account. Set your password here

Create an Ionic 3 & Mobiscroll starter with the CLI:

$ mobiscroll start ionic myStarter

Run this command for Ionic 4 & Mobiscroll starter:

$ mobiscroll start ionic-angular myStarter

Step 3.Copy the code into your app.

Copy TS
Copy HTML
Copy CSS
Copy Module

Step 4.Run ionic serve in the root folder of your app 🎉

Copy command
$ ionic serve

And voilà, everything should be running smoothly.

Install demo in your app
Follow this quick, two minute install guide
Close window

Step 1.Install the Mobiscroll CLI from npm

Copy command
$ npm install -g @mobiscroll/cli

The CLI makes configuring your apps super simple 👍

Step 2.Run the following command in the root folder of your Ionic project

Copy command
$ mobiscroll config ionic --version=4

You will be prompted to log in with your mobiscroll account. Set your password here

Run this command for Ionic 5 & React Mobiscroll starter:

$ mobiscroll start react-ionic myStarter

Step 3.Copy the code into your app.

Copy TSX
Copy CSS

Step 4.Run ionic serve in the root folder of your app 🎉

Copy command
$ ionic serve

And voilà, everything should be running smoothly.

Customize & try demos locally
How would you like to do it?
Install demo in your app
Follow this quick, two minute install guide
Close window

Step 1.Install the Mobiscroll CLI from npm

Copy command
$ npm install -g @mobiscroll/cli

The CLI makes configuring your apps super simple 👍

Step 2.Run the following command in the root folder of your Angular project

Copy command
$ mobiscroll config angular --version=4

You will be prompted to log in with your mobiscroll account. Set your password here

Step 3.Copy the code into your app. HTML goes into the markup, TS into Typescript.

Copy TS
Copy HTML
Copy CSS
Copy Module

Step 4.Run ng serve in the root folder of your app 🎉

Copy command
$ ng serve

And voilà, everything should be running smoothly.

Thanks for downloading
Try and customize the app locally

Extract the zip file and run the project like any Ionic app. Make sure to have Ionic CLI installed and open the terminal in the app root folder.

Step 1. Run in root folder
$ npm install
Step 2. Start the app
$ ionic serve

Let us know if we can help and enjoy!

Thanks for downloading
Customize demos locally

Everything is set up so that you can dig in right away and start exploring.

We have set up a trial so that you can try the demos locally.

Extract the zip file and open the demo in your favorite browser. To install Mobiscroll in your project follow instructions from this page.


Let us know if we can help and enjoy! 👍

Thanks for downloading
Customize demos locally

Please extract the zip file and run the project like any Angular CLI app. Make sure to have the Angular CLI installed.

For installation and usage, extract the zip file and open a terminal window and follow these steps.

Step 1. Run in root folder
$ npm install
Step 2. Start the app
$ ng serve --open

Let us know if we can help and enjoy! 👍

Thanks for downloading
Customize demos locally

Everything is set up so that you can dig in right away and start exploring.

We have set up a trial so that you can try the demos locally.

The easiest way to get started is to follow the installation steps and by grabbing the code directly from the demo page. Let us know if we can help and enjoy! 👍

You'll find a fully functional Kitchen-sink Ionic app in the zip file.

Thanks for downloading
Customize demos locally

Everything is set up so that you can dig in right away and start exploring.

We have set up a trial so that you can try the demos locally.

The demos are using Babel's in-browser ES6 and JSX transformer.
Extract the zip file and open the demo in your browser. To install Mobiscroll in your project follow instructions from this page.


Let us know if we can help and enjoy! 👍

Customize & try this demo locally
Sign in or start your free trial

We have to set you up with a trial for this to run 👍

Email address

Need to update your password?
Demos
Theme Select
Mobiscroll
Material
Material Dark
iOS
iOS Dark
Windows
Windows Dark
Language Locale
See other demos and change options
Theme
Locale
See other demos